#include <Array.au3>
#include "FLANN.au3"

; Alle 3D-Punktkoordinaten (hier zufllige) in ein 2D-Array mit 3 Spalten (=3D-Koordinaten)
Global $a_DataSet[500][3]
For $i = 0 To UBound($a_DataSet) - 1
	$a_DataSet[$i][0] = Random(0, 100)
	$a_DataSet[$i][1] = Random(0, 100)
	$a_DataSet[$i][2] = Random(0, 100)
Next
_ArrayDisplay($a_DataSet, "Alle Punktkoordinaten")
; Das AutoIt-Array in eine FLANN-UDF-Matrix umwandeln
$t_DataSet = _FLANN_Data2C($a_DataSet)

#Region Abstnde zu bestimmten Punkten (nicht Teil des Datasets)
; Punkte deren nearest neighbors in der Menge des Dataset gecheckt werden sollen:
Global $a_TestSet[][3] = [[50, 50, 50], [25, 25, 25], [90, 70, 80]]
Global $t_TestSet = _FLANN_Data2C($a_TestSet) ; AutoIt-Matrix wieder in FLANN-UDF-Matrix umwandeln

Global $nn = 2 ; Anzahl an nearest neighbours pro Punkt
$a_NNs = _flann_find_nearest_neighbors($t_DataSet, $t_TestSet, $nn) ; Fhre eine Nearest-Neighboursuche zu den $a_TestSet-Punkten innerhalb der Menge $a_DataSet durch
$a_Ind = $a_NNs[0]     ; die Matrix mit den Indizes der NN-Punkte
$a_dists = $a_NNs[1]   ; die Matrix mit den Distanzen zwischen den NN-Punkten

; Wenn eine FLANN-UDF-Matrix nicht mehr bentigt wird, sollte man sie manuell killen
_FLANN_DelMatrix($t_TestSet)

; Alle Punkte in $a_TestSet durchgehen und ihre dazugehrigen NN-Punkte ausgeben:
For $i = 0 To UBound($a_Ind) - 1
	ConsoleWrite(StringFormat("Punkt Nr. %-3d (%.2f, %.2f, %.2f):\n", $i, $a_TestSet[$i][0], $a_TestSet[$i][1], $a_TestSet[$i][2]))
	For $j = 0 To UBound($a_Ind, 2) - 1
		$ind = $a_Ind[$i][$j]
		ConsoleWrite(StringFormat("\t%3d (%.2f, %.2f, %.2f) - d = %.3f:\n", $a_Ind[$i][$j], $a_DataSet[$ind][0], $a_DataSet[$ind][1], $a_DataSet[$ind][2], Sqrt($a_dists[$i][$j])))
	Next
Next
#EndRegion Abstnde zu bestimmten Punkten (nicht Teil des Datasets)


#Region Nearest Neighbours innerhalb des Datasets
$nn = 2 ; Anzahl an nearest neighbours pro Punkt (hier mindestens 2, da der erste immer der Punkt selbst ist - klar da ist die Distanz ja auch 0.0)
$a_NNs = _flann_find_nearest_neighbors($t_DataSet, $t_DataSet, $nn) ; Fhre eine Nearest-Neighboursuche innerhalb der Menge $a_DataSet durch
$a_Ind = $a_NNs[0]     ; die Matrix mit den Indizes der NN-Punkte
$a_dists = $a_NNs[1]   ; die Matrix mit den Distanzen zwischen den NN-Punkten

; Alle Punkte in $a_DataSet durchgehen und ihre dazugehrigen NN-Punkte ausgeben:
For $i = 0 To UBound($a_Ind) - 1
	ConsoleWrite(StringFormat("Punkt Nr. %-3d (%.2f, %.2f, %.2f):\n", $i, $a_DataSet[$i][0], $a_DataSet[$i][1], $a_DataSet[$i][2]))
	For $j = 1 To UBound($a_Ind, 2) - 1 ; beginne bei 1 statt 0 da 0 der Punkt selbst ist (logisch da Distanz hier gleich 0)
		$ind = $a_Ind[$i][$j]
		ConsoleWrite(StringFormat("\t%3d (%.2f, %.2f, %.2f) - d = %.3f:\n", $a_Ind[$i][$j], $a_DataSet[$ind][0], $a_DataSet[$ind][1], $a_DataSet[$ind][2], Sqrt($a_dists[$i][$j])))
	Next
Next
#EndRegion Nearest Neighbours innerhalb des Datasets

; Wenn eine FLANN-UDF-Matrix nicht mehr bentigt wird, sollte man sie manuell killen
_FLANN_DelMatrix($t_DataSet)


